package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.DERBitString;

public class KeyUsage extends DERBitString {
   public static final int digitalSignature = 128;
   public static final int nonRepudiation = 64;
   public static final int keyEncipherment = 32;
   public static final int dataEncipherment = 16;
   public static final int keyAgreement = 8;
   public static final int keyCertSign = 4;
   public static final int cRLSign = 2;
   public static final int encipherOnly = 1;
   public static final int decipherOnly = 32768;

   public static DERBitString getInstance(Object obj) {
      if (obj instanceof KeyUsage) {
         return (KeyUsage)obj;
      } else {
         return obj instanceof X509Extension ? new KeyUsage(DERBitString.getInstance(X509Extension.convertValueToObject((X509Extension)obj))) : new KeyUsage(DERBitString.getInstance(obj));
      }
   }

   public KeyUsage(int usage) {
      KeyUsage var10000 = this;
      byte[] var2 = DERBitString.getBytes(usage);
      var10000.<init>(var2, DERBitString.getPadBits(usage));
   }

   public KeyUsage(DERBitString usage) {
      KeyUsage var10000 = this;
      byte[] var2 = usage.getBytes();
      var10000.<init>(var2, usage.getPadBits());
   }

   public String toString() {
      byte[] var1;
      return super.data.length == 1 ? "KeyUsage: 0x" + Integer.toHexString(super.data[0] & 255) : "KeyUsage: 0x" + Integer.toHexString(((var1 = super.data)[1] & 255) << 8 | var1[0] & 255);
   }
}
